<?php
/***********************************************************************************
************************************************************************************
***                                                                              ***
***   XTC Template Framework 2.2.1                                               ***
***                                                                              ***
***   Copyright (c) 2010-2012 Monev Software LLC,  All Rights Reserved           ***
***                                                                              ***
***   This program is free software; you can redistribute it and/or modify       ***
***   it under the terms of the GNU General Public License as published by       ***
***   the Free Software Foundation; either version 2 of the License, or          ***
***   (at your option) any later version.                                        ***
***                                                                              ***
***   This program is distributed in the hope that it will be useful,            ***
***   but WITHOUT ANY WARRANTY; without even the implied warranty of             ***
***   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              ***
***   GNU General Public License for more details.                               ***
***                                                                              ***
***   You should have received a copy of the GNU General Public License          ***
***   along with this program; if not, write to the Free Software                ***
***   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA   ***
***                                                                              ***
***   See COPYRIGHT.php for more information.                                    ***
***   See LICENSE.php for more information.                                      ***
***                                                                              ***
***   www.joomlaxtc.com                                                          ***
***                                                                              ***
************************************************************************************
***********************************************************************************/

defined('_JEXEC') or die;

jimport('joomla.form.formfield');

class JFormFieldStylegroups extends JFormField {

	protected	$type = 'Stylegroups';

	protected function getInput()	{

		if (!function_exists('xtcsortfn')) {
				function xtcsortfn($a, $b) {
			   return strnatcmp($a[0],$b[0]);
			}
		}

		jimport( 'joomla.filesystem.folder' );
		JHTML::_( 'behavior.modal', 'a.modal' );

		$live_site = JURI::root();
		$template = basename(dirname(dirname(dirname(__FILE__))));
		$document = JFactory::getDocument();
		$id = JRequest::getInt('id');

		$document->addStyleSheet($live_site."templates/$template/XTC/XTC.css",'text/css');
		$path = JPATH_ROOT.DS.'templates'.DS.$template;
		$files = JFolder::files($path.DS.'parameters','xml');
		$onopen = "var iSize;
    var iFrame = this.asset;
    iFrame.addEvent('load', function(){
      var iBody = (iFrame.contentDocument) ? iFrame.contentDocument.getElementsByTagName('body')[0] : iFrame.contentWindow.document.getElementsByTagName('body')[0];

	 iSize = {x:this.size.x, y:iBody.offsetHeight};
      var per = (window.innerHeight * 0.9).toInt();
      iSize.y = (iSize.y > per) ? per : iSize.y ;
      iFrame.setStyles({'height':'100%'});

      this.resize(iSize, false);
    }.bind(this));";

		$parmsfound=false;
		$prefix = trim($this->element['group']);
		$label = trim($this->element['label']);
		$parameters = array();
		foreach ($files as $file) {
			@list($filename,$extension)=explode('.',$file);
			if ($extension != 'xml') continue; // Not an XML
			if (strpos($filename,$prefix) !== 0) continue; // Not the right prefix
			$xmlFile = $path.DS.'parameters'.DS.$file;
			if (is_readable($xmlFile)) {
				$xmlData = file_get_contents($xmlFile);
				$xml = JFactory::getXMLParser('Simple');
				$xml->loadString($xmlData);
				$name = $xml->document->getElementByPath('name');
				$description = $xml->document->getElementByPath('description');
				$name = $name ? trim($name->data()) : $filename;
				$description = $description ? trim($description->data()) : '';
			}
			else {
				$name = $filename;
				$description = '';
			}

			$thumbnail = '';
			if (file_exists($path.DS.'parameters'.DS.$filename.'.gif')) {$thumbnail = $filename.'.gif'; }
			elseif (file_exists($path.DS.'parameters'.DS.$filename.'.jpg')) {$thumbnail = $filename.'.jpg'; }
			elseif (file_exists($path.DS.'parameters'.DS.$filename.'.png')) {$thumbnail = $filename.'.png'; }

			$fullimage = '';
			if (file_exists($path.DS.'parameters'.DS.$filename.'_full.gif')) {$fullimage = $filename.'_full.gif'; }
			elseif (file_exists($path.DS.'parameters'.DS.$filename.'_full.jpg')) {$fullimage = $filename.'_full.jpg'; }
			elseif (file_exists($path.DS.'parameters'.DS.$filename.'_full.png')) {$fullimage = $filename.'_full.png'; }
			$parameters[] = array($name,$filename,$description,$thumbnail,$fullimage);
		}

		usort($parameters, "xtcsortfn");

		require_once $path.DS.'XTC'.DS.'XTC_library.php';
		$templateParameters = xtcLoadParams($id);

		$html = '<div class="styleGroups">';
		
		$count = count($parameters);
		$openClass = ($count ==1) ? ' open' : '';
		foreach ($parameters as $parameter) { // Draw parameters

			list($name,$filename,$description,$thumbnail,$fullimage) = $parameter;

			$params = isset($templateParameters->group->$filename) ? $templateParameters->group->$filename : new stdClass();

			$html .= '<div id="style'.$filename.'" class="xtcPane'.$openClass.'">';
				// if ($count > 1) $html .= '<a href="javascript:void(0);" onclick="switchpane(\'style'.$filename.'\');" class="xtcPaneName"><span>'.$name.'</span></a>';
				$html .= '<a href="javascript:void(0);" onclick="switchpane(\'style'.$filename.'\');" class="xtcPaneName"><span>'.$name.'</span></a>';

				$html .= '<div id="pane'.$filename.'" class="xtcPaneContents">';

					$html .= '<table class="xtcStyleTable"><tr>';
						if ($thumbnail) {
							$thumbnailURL = $live_site.'templates/'.$template.'/parameters/'.$thumbnail;
							if ($fullimage) {
								$fullimageURL = $live_site.'templates/'.$template.'/parameters/'.$fullimage;
								$headerimg_size = getimagesize($path.DS.'parameters'.DS.$fullimage);
								$width = $headerimg_size[0];
								$height = $headerimg_size[1]; 
								$onclick = "onclick=\"MyWindow=window.open('$fullimageURL','_blank','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=$width,height=$height'); return false;\"";
								$html .= '<td class="styleImageTd"><img class="styleImage" style="cursor:pointer" '.$onclick.' src="'.$thumbnailURL.'" alt="Full image" /></td>';
							}
							else {
								$html .= '<td class="styleImageTd"><img class="styleImage" src="'.$thumbnailURL.'" alt="" /></td>';
							}
						}
						$html .= '<td>';
						if ($description) $html .= '<div class="layoutDescription">'.$description.'</div>';
					$html .= '</td></tr></table>';
						
			

			$form = new JForm('jxtc');
			$form->addFieldPath(JPATH_ROOT.DS.'templates'.DS.$template.DS.'XTC'.DS.'elements');
			$xmlFile = $path.DS.'parameters'.DS.$filename.'.xml';

			$form->loadFile($xmlFile);
			$getFieldsets = $form->getFieldsets();

			foreach ($getFieldsets as $fieldsets => $fieldset) {
				$label = isset($fieldset->label) ? trim($fieldset->label) : $fieldset->name;
				$description = isset($fieldset->description) ? trim($fieldset->description) : '';
				if (count($getFieldsets) > 1) { // Split in xtc fieldsets
					$html .= '<fieldset class="xtcFieldset">';
					if ($label) { $html .= '<legend class="xtcFieldsetLegend">'.$label.'</legend>'; }
				}
				if ($description) { $html .= '<div class="xtcFieldsetDescription">'.$description.'</div>'; }
				$html .= '<ul class="adminformlist xtcFormList">';
				foreach($form->getFieldset($fieldset->name) as $field) {
					$xtcName = substr($field->name,7,-1);
					if (isset($params->$xtcName)) { $field->value = $params->$xtcName; }
					$field->name = str_replace('params[','xtcparam['.$prefix.']['.$filename.'][',$field->name);
					$html .= '<li>'.$field->getLabel().$field->getInput().'</li>';
				}
				$html .= '</ul>';
				if (count($getFieldsets) > 1) {
					$html .= '</fieldset>';
				}
			}
			$html .= '<div style="clear:both"></div>';
//			if ($count > 1) { 
//				$html .= '<a style="float:right" href="#">Top</a>';
//				$html .= '<a style="float:right" href="javascript:void(0);" onclick="switchpane(\'style'.$filename.'\');" >Close</a>';
//			}
			$html .= '</div>'; // panecontents
			$html .= '</div>'; // xtcpane
			$openClass='';
		}
		$html .= '</div>';
		return $html;
	}

	protected function getLabel()	{
		return '';
	}
}
