<?php 
/*
	JoomlaXTC XTC Template Overrides

	Copyright (C) 2011  Monev Software LLC.	All Rights Reserved.
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	THIS LICENSE MIGHT NOT APPLY TO OTHER FILES CONTAINED IN THE SAME PACKAGE.
	
	Monev Software LLC
	www.joomlaxtc.com
*/

defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers');
?>
<div class="joomla <?php echo $this->pageclass_sfx;?>">
	<div class="blog">

		<?php if ($this->params->get('show_category_title', 1) OR $this->params->get('page_subheading') OR $this->params->get('show_page_heading', 1)) : ?>
			<div class="componentheading">
				<?php if ($this->params->get('show_page_heading', 1)) : ?>
						<span class="subheading-category"><?php echo $this->escape($this->params->get('page_heading')); ?></span>
				<?php endif; ?>
				<?php echo $this->escape($this->params->get('page_subheading')); ?>
				<?php if ($this->params->get('show_category_title')) : ?>
					<span class="subheading-category"><?php echo $this->category->title;?></span>
				<?php endif; ?>
			</div>
    	<div class="headingstripe"></div>
		<?php endif; ?>

		<?php if ($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) : ?>
			<div class="description">
				<?php if ($this->params->get('show_description_image') && $this->category->getParams()->get('image')) : ?>
					<img src="<?php echo $this->category->getParams()->get('image'); ?>"/>
				<?php endif; ?>
				<?php if ($this->params->get('show_description') && $this->category->description) : ?>
					<?php echo JHtml::_('content.prepare', $this->category->description); ?>
				<?php endif; ?>
				<div class="clr"></div>
			</div>
		<?php endif; ?>
		
		<?php $leadingcount=0 ; ?>
		<?php if (!empty($this->lead_items)) : ?>
			<div class="leadingarticles">
				<?php foreach ($this->lead_items as &$item) : ?>
					<div class="leading-<?php echo $leadingcount; ?><?php echo $item->state == 0 ? ' system-unpublished' : null; ?>">
						<?php
							$this->item = &$item;
							echo $this->loadTemplate('item');
						?>
					</div>
					<?php
						$leadingcount++;
					?>
				<?php endforeach; ?>
			</div>
		<?php endif; ?>
		
		<?php
			$introcount=(count($this->intro_items));
			$counter=0;

			$columncount = (int) $this->columns;
			$count   = $introcount;
			$rows    = ceil($count / $columncount);
			$columns = array();
			$multi_column_order = $this->params->get('multi_column_order', 1);

			// create intro columns
			$j=0;
			foreach ($this->intro_items as $key => &$item) {
				if ($multi_column_order == 0) { // order down
					$column = intval($j / $rows);
				} else { // order across
					$column = $j % $columncount;
				}
				if (!isset($columns[$column])) {
					$columns[$column] = '';
				}

				$this->item = &$item;
				$columns[$column] .= $this->loadTemplate('item');
				$j++;
			}
			// Render columns
			$count = count($columns);
			if ($count) {
				if ($count != 1) {
					echo '<div class="teaserarticles multicolumns">';
				} else {
					echo '<div class="teaserarticles">';
				}
				for ($j = 0; $j < $count; $j++) {
					$firstlast = "";
					if ($count != 1) {
						if ($j == 0) $firstlast = "first";
						if ($j == $count - 1) $firstlast = "last";
					}
					echo '<div class="'.$firstlast.' float-left width'.intval(100 / $count).'">'.$columns[$j].'</div>';
				}
				echo '</div>';
			}
		?>		

		<?php if (!empty($this->link_items)) : ?>
			<?php echo $this->loadTemplate('links'); ?>
		<?php endif; ?>

		<?php if (!empty($this->children[$this->category->id])&& $this->maxLevel != 0) : ?>
			<div class="morearticles">
				<?php // echo JTEXT::_('JGLOBAL_SUBCATEGORIES'); ?>
				<?php echo $this->loadTemplate('children'); ?>
			</div>
		<?php endif; ?>

		<?php if (($this->params->def('show_pagination', 1) == 1  || ($this->params->get('show_pagination') == 2)) && ($this->pagination->get('pages.total') > 1)) : ?>
			<div class="pagination">
				<?php  if ($this->params->def('show_pagination_results', 1)) : ?>
					<p class="results">
						<?php echo $this->pagination->getPagesCounter(); ?>
					</p>
				<?php endif; ?>
				<?php echo $this->pagination->getPagesLinks(); ?>
			</div>
		<?php  endif; ?>
	</div>
</div>