<?php 
/*
	JoomlaXTC XTC Template Overrides

	Copyright (C) 2011  Monev Software LLC.	All Rights Reserved.
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	THIS LICENSE MIGHT NOT APPLY TO OTHER FILES CONTAINED IN THE SAME PACKAGE.
	
	Monev Software LLC
	www.joomlaxtc.com
*/

defined('_JEXEC') or die;

// Create a shortcut for params.
$params = &$this->item->params;
$canEdit	= $this->item->params->get('access-edit');
JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::core();

$src = '/img src=[\'"]?([^\'" >]+)[\'" >]/'; 
preg_match($src, $this->item->introtext, $match);
$content = preg_replace("/<img[^>]+\>/i", " ", $this->item->introtext); 
?>
<div class="item  <?php if ($this->item->state == 0) echo 'unpublished' ?>">
	<?php if ($match) { ?>
		<div class="cat_img">
			<img <?php echo $match[0] ?> />
		</div>
	<?php }?> 

	<div class="cat<?php if ($params->get('show_create_date')){ ?>_rest<?php }?>">
		<?php if ($params->get('show_create_date') || $params->get('show_title')) : ?>
			<div class="headline">
			<?php if ($params->get('show_create_date')) : ?>
					<?php
						$month=array('01'=>'Jan','02'=>'Feb','03'=>'Mar','04'=>'Apr','05'=>'May','06'=>'Jun','07'=>'Jul','08'=>'Aug','09'=>'Sep','10'=>'Oct','11'=>'Nov','12'=>'Dec');
						list($date,$time)=explode(' ',$this->item->created);
						list($yy,$mm,$dd)=explode('-', $date);
					?>
					<div class="articlebadgeWrap">
						<acronym class="published">
							<span class="articlebadgeDay"><?php echo $dd; ?></span>
							<span class="articlebadgeMonth"><?php echo $month[$mm]; ?></span>
						</acronym>   
					</div>
				<?php endif; ?>

				<?php if ($params->get('show_title')) : ?>
					<h3 class="title">
						<?php if ($params->get('link_titles') && $params->get('access-view')) : ?>
							<a href="<?php echo JRoute::_(ContentHelperRoute::getArticleRoute($this->item->slug, $this->item->catid)); ?>">
							<?php echo $this->escape($this->item->title); ?></a>
						<?php else : ?>
							<?php echo $this->escape($this->item->title); ?>
						<?php endif; ?>
					</h3>
				<?php endif; ?>
			</div>
		<?php endif; ?>

		<div class="articleinfo">
			<?php if ($params->get('show_author') && !empty($this->item->author )) : ?>
				<div class="author floatLeft tmpspacer">
					<?php $author =  $this->item->author; ?>
					<?php $author = ($this->item->created_by_alias ? $this->item->created_by_alias : $author);?>
					<?php if (!empty($this->item->contactid ) &&  $params->get('link_author') == true):?>
						<?php 	echo JText::sprintf('COM_CONTENT_WRITTEN_BY' , JHtml::_('link',JRoute::_('index.php?option=com_contact&view=contact&id='.$this->item->contactid),$author)); ?>
					<?php else :?>
						<?php echo JText::sprintf('COM_CONTENT_WRITTEN_BY', $author); ?>
					<?php endif; ?>
				</div>
			<?php endif; ?>
			<?php if ($params->get('show_modify_date')) : ?>
				<div class="modified floatLeft tmpspacer">
					<?php echo JText::sprintf('COM_CONTENT_LAST_UPDATED', JHtml::_('date',$this->item->modified, JText::_('DATE_FORMAT_LC2'))); ?>
				</div>
			<?php endif; ?>
			<?php if ($params->get('show_publish_date')) : ?>
				<div class="published floatLeft tmpspacer">
					<?php echo JText::sprintf('COM_CONTENT_PUBLISHED_DATE', JHtml::_('date',$this->item->publish_up, JText::_('DATE_FORMAT_LC2'))); ?>
				</div>
			<?php endif; ?>
			<?php if ($params->get('show_hits')) : ?>
				<div class="hits floatLeft tmpspacer">
					<?php echo JText::sprintf('COM_CONTENT_ARTICLE_HITS', $this->item->hits); ?>
				</div>
			<?php endif; ?>



			<?php if ($params->get('show_category') or $params->get('show_parent_category')) : ?>
				<div class="floatLeft tmpspacer">
					<?php // echo JText::_('COM_CONTENT_ARTICLE_INFO'); ?>
					<?php echo JText::sprintf('Published In:');?>
					<?php if ($params->get('show_parent_category') && $this->item->parent_id != 1) : ?>
						<span>
							<?php
								$title = $this->escape($this->item->parent_title);
								$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($this->item->parent_id)) . '">' . $title . '</a>';
							?>
							<?php if ($params->get('link_parent_category')) : ?>
								<?php // echo JText::sprintf('COM_CONTENT_PARENT', $url); ?>
								<?php echo $url ?>
								<?php else : ?>
								<?php // echo JText::sprintf('COM_CONTENT_PARENT', $title); ?>
								<?php echo $title; ?>
							<?php endif; ?>
						</span>
						<?php if ($params->get('show_category')) : ?>-<?php endif; ?>
					<?php endif; ?>
					<?php if ($params->get('show_category')) : ?>
							<span>
								<?php
									$title = $this->escape($this->item->category_title);
									$url = '<a href="' . JRoute::_(ContentHelperRoute::getCategoryRoute($this->item->catid)) . '">' . $title . '</a>';
								?>
								<?php if ($params->get('link_category')) : ?>
									<?php // echo JText::sprintf('COM_CONTENT_CATEGORY', $url); ?>
									<?php echo $url; ?>
									<?php else : ?>
									<?php // echo JText::sprintf('COM_CONTENT_CATEGORY', $title); ?>
									<?php echo $title; ?>
								<?php endif; ?>
							</span>
					<?php endif; ?>
				</div>
			<?php endif; ?>
            			<?php if ($canEdit) : ?>
				<span class="icon edit floatRight tmpspacer">
					<?php echo JHtml::_('icon.edit', $this->item, $params); ?>
				</span>
			<?php endif; ?>
			<?php if ($params->get('show_email_icon')) : ?>
				<span class="icon email floatRight tmpspacer">
					<?php echo JHtml::_('icon.email', $this->item, $params); ?>
				</span>
			<?php endif; ?>
			<?php if ($params->get('show_print_icon')) : ?>
				<span class="icon print floatRight tmpspacer">
					<?php echo JHtml::_('icon.print_popup', $this->item, $params); ?>
				</span>
			<?php endif; ?>
			<div style="clear:both;"></div>
		</div>

		<?php echo $this->item->event->afterDisplayTitle; ?>

		<?php echo $this->item->event->beforeDisplayContent; ?>

		<?php	echo $content; ?>
		
		<?php if ($params->get('show_readmore') && $this->item->readmore) :
			if ($params->get('access-view')) :
				$link = JRoute::_(ContentHelperRoute::getArticleRoute($this->item->slug, $this->item->catid));
			else :
				$menu = JFactory::getApplication()->getMenu();
				$active = $menu->getActive();
				$itemId = $active->id;
				$link1 = JRoute::_('index.php?option=com_users&view=login&Itemid=' . $itemId);
				$returnURL = JRoute::_(ContentHelperRoute::getArticleRoute($this->item->slug, $this->item->catid));
				$link = new JURI($link1);
				$link->setVar('return', base64_encode($returnURL));
			endif;
		?>
			<p class="readmore">
				<a href="<?php echo $link; ?>">
					<?php if (!$params->get('access-view')) :
						echo JText::_('COM_CONTENT_REGISTER_TO_READ_MORE');
					elseif ($readmore = $this->item->alternative_readmore) :
						echo $readmore;
						if ($params->get('show_readmore_title', 0) != 0) :
						    echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
						endif;
					elseif ($params->get('show_readmore_title', 0) == 0) :
						echo JText::sprintf('COM_CONTENT_READ_MORE_TITLE');
					else :
						echo JText::_('COM_CONTENT_READ_MORE');
						echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
					endif; ?></a>
			</p>
		<?php endif; ?>
		<?php echo $this->item->event->afterDisplayContent; ?>
	</div>
</div>
